Option Strict Off
Option Explicit On

Friend Class MainFrm
    Inherits System.Windows.Forms.Form

    Dim Cnt, NewInterval, Interval, Repeats As Object
    Dim CommandNo As Short
    Dim bRun As Object
    Dim bCmdGiven As Boolean
    Dim NumRepeats As Short
    Dim sCmd As String
    Dim sS2, sS1, sS3 As Object
    Dim sS4 As String
    Const MAX_COMMANDS As Short = 30
    Dim UIstore(MAX_COMMANDS + 1, 4) As Object
    Dim ctrl As Control
    Dim sourcefile As String
    Dim scaler As Integer
    Dim pageguard As Boolean = False

    ' Supported Commands:

    'POSN 
    'PSTT 
    'AMOV 
    'RMOV 
    'SAMV 
    'SRMV 
    'STOP 
    'STAT
    'ACCF
    'ACCS
    'ACCI
    'DRON
    'DROF
    'DRST
    'OPTN
    'SAVE
    'REL1
    'REL2
    'BAUD

    Dim sResponse, sFirstResponse As Object
    Dim sLastResponse As String
    Dim sAddr As String
    Dim CmdStage As Short

    Dim bFlag As Boolean
    Dim StepperNo As Short
    Const BADARG As Short = 4
    Const BAD_COMMAND As Short = 5
    Const MOTOR_NAME As Short = 6
    Const STEP_VALUE As Short = 7
    Const DIRECTION As Short = 8
    Const STEPRATE As Short = 9
    Const Delay As Short = 10
    Const INPUT1 As Short = 11
    Const INPUT2 As Short = 12
    Const ON_OFF As Short = 13

    Private Sub CmdExit_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs)
        Comm1.Close()
        Me.Close()
    End Sub

    Private Sub CmdRun_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles CmdRun.Click

        If Comm1.IsOpen <> True Then
            MsgBox("Configure Comm Port", , "NO SERIAL CONNECTION")
            Exit Sub
        End If

        Repeats = 0
        CommandNo = 0
        bRun = True
        CmdStage = 0
        sResponse = ""

    End Sub

    Private Sub Comm1_OnComm(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Comm1.DataReceived
        Dim i As Short
        Dim NC As Short
        Dim cc As String
        Control.CheckForIllegalCrossThreadCalls = False

        'It returns a response of -1 if it fails or times out
        'It returns a response of 0 if it is still reading the serial line
        'It returns a response of 1 if it is successful

        Do
            NC = Comm1.BytesToRead

            If (NC > 0) Then
                cc = Chr(Comm1.ReadChar)

                If cc <> Chr(13) And cc <> Chr(10) Then
                    sResponse = sResponse & cc
                End If

                If cc = Chr(13) Then
                    TxtIn.Text = sResponse
                    i = InStr(sResponse, "#")

                    If i = 1 Then
                        sFirstResponse = sResponse
                        Call DecodeResponse()
                    End If

                    i = InStr(sResponse, "!")

                    If i = 1 Then
                        sLastResponse = sResponse
                    End If

                    sResponse = ""

                End If
            End If

        Loop While (NC > 0)

    End Sub
    Private Sub DecodeResponse()
        Dim j As Short
        Dim iMask As Short
        Dim sS As String = ""
        Dim iBit As Short
        Dim ival As Short
        Dim lVal As Integer

        If sCmd = "STAT" Then
            sS = Mid(sResponse, 4)
            ival = Val(sS)
            iMask = 1
            For j = 1 To 4
                iBit = ival And iMask
                If j = 1 Then
                    ChkMove1.CheckState = System.Windows.Forms.CheckState.Unchecked
                    If iBit <> 0 Then ChkMove1.CheckState = System.Windows.Forms.CheckState.Checked
                End If
                If j = 2 Then
                    ChkMove2.CheckState = System.Windows.Forms.CheckState.Unchecked
                    If iBit <> 0 Then ChkMove2.CheckState = System.Windows.Forms.CheckState.Checked
                End If
                If j = 3 Then
                    ChkMove3.CheckState = System.Windows.Forms.CheckState.Unchecked
                    If iBit <> 0 Then ChkMove3.CheckState = System.Windows.Forms.CheckState.Checked
                End If
                If j = 4 Then
                    ChkMove4.CheckState = System.Windows.Forms.CheckState.Unchecked
                    If iBit <> 0 Then ChkMove4.CheckState = System.Windows.Forms.CheckState.Checked
                End If
                iMask = iMask * 2
            Next j
            For j = 1 To 4
                iBit = ival And iMask
                If j = 1 Then
                    ChkDirn1.CheckState = System.Windows.Forms.CheckState.Unchecked
                    If iBit <> 0 Then ChkDirn1.CheckState = System.Windows.Forms.CheckState.Checked
                End If
                If j = 2 Then
                    ChkDirn2.CheckState = System.Windows.Forms.CheckState.Unchecked
                    If iBit <> 0 Then ChkDirn2.CheckState = System.Windows.Forms.CheckState.Checked
                End If
                If j = 3 Then
                    ChkDirn3.CheckState = System.Windows.Forms.CheckState.Unchecked
                    If iBit <> 0 Then ChkDirn3.CheckState = System.Windows.Forms.CheckState.Checked
                End If
                If j = 4 Then
                    ChkDirn4.CheckState = System.Windows.Forms.CheckState.Unchecked
                    If iBit <> 0 Then ChkDirn4.CheckState = System.Windows.Forms.CheckState.Checked
                End If
                iMask = iMask * 2
            Next j
            For j = 1 To 4
                iBit = ival And iMask
                If j = 1 Then
                    ChkLimit1.CheckState = System.Windows.Forms.CheckState.Unchecked
                    If iBit <> 0 Then ChkLimit1.CheckState = System.Windows.Forms.CheckState.Checked
                End If
                If j = 2 Then
                    ChkLimit2.CheckState = System.Windows.Forms.CheckState.Unchecked
                    If iBit <> 0 Then ChkLimit2.CheckState = System.Windows.Forms.CheckState.Checked
                End If
                If j = 3 Then
                    ChkLimit3.CheckState = System.Windows.Forms.CheckState.Unchecked
                    If iBit <> 0 Then ChkLimit3.CheckState = System.Windows.Forms.CheckState.Checked
                End If
                If j = 4 Then
                    ChkLimit4.CheckState = System.Windows.Forms.CheckState.Unchecked
                    If iBit <> 0 Then ChkLimit4.CheckState = System.Windows.Forms.CheckState.Checked
                End If
                iMask = iMask * 2
            Next j
        End If
        If sCmd = "PSTT" Then
            StepperNo = Val(Mid(sS, 2, 2))

            sS = Mid(sResponse, 4)
            sS = Trim(sS)
            Call GetVals(sS, StepperNo)
            lVal = Val(sS)
            TxtPosition1.Text = sS1
            TxtPosition2.Text = sS2
            TxtPosition3.Text = sS3
            TxtPosition4.Text = sS4
        End If

    End Sub
    Sub GetVals(ByRef sS As String, ByRef iSN As Short)
        Dim i As Short

        sS1 = ""
        sS2 = ""
        sS3 = ""
        sS4 = ""
        i = InStr(1, sS, " ")
        If i > 1 Then
            sS1 = Mid(sS, 1, i - 1)
            sS = Mid(sS, i + 1, 50)
        Else
            sS1 = sS
        End If

        i = InStr(1, sS, " ")

        If i > 1 Then
            sS2 = Mid(sS, 1, i - 1)
            sS = Mid(sS, i + 1, 50)
        Else
            sS2 = sS
        End If

        i = InStr(1, sS, " ")

        If i > 1 Then
            sS3 = Mid(sS, 1, i - 1)
            sS = Mid(sS, i + 1, 50)
        Else
            sS3 = sS
        End If

        i = InStr(1, sS, " ")

        If i > 1 Then
            sS4 = Mid(sS, 1, i - 1)
            sS = Mid(sS, i + 1, 50)
        Else
            sS4 = sS
        End If

    End Sub

    Private Sub CheckCmd(ByRef sS As String)

        Dim iAddr As Object
        Dim sParam2, sParam1 As String
        Dim lParam1 As Integer
        Dim bSend As Object
        Dim bNumeric As Boolean

        bNumeric = False
        sS = UCase(sS)
        sCmd = ""
        sParam1 = ""
        sParam2 = ""
        iAddr = Val(Mid(sS, 2, 2))
        sCmd = Mid(sS, 5, 4)
        sParam1 = Mid(sS, 9)
        If IsNumeric(sParam1) Then
            lParam1 = Val(sParam1)
            bNumeric = True
        End If

        bSend = False

        Select Case sCmd

            Case "POSN" 'SET MOTOR POSITION
                If bNumeric = True Then
                    TxtOut.Text = sS
                    bSend = True
                Else
                    MsgBox("Parameter missing for POSN command")
                End If

            Case "PSTT" 'RETURN POSITION OF MOTORS
                TxtOut.Text = sS
                bSend = True

            Case "AMOV" 'ABSOLUTE MOTOR MOVE
                If bNumeric = True Then
                    TxtOut.Text = sS
                    bSend = True
                Else
                    MsgBox("Parameter missing for AMOV command")
                End If

            Case "RMOV" 'RELATIVE MOTOR MOVE
                If bNumeric = True Then
                    TxtOut.Text = sS
                    bSend = True
                Else
                    MsgBox("Parameter missing for RMOV command")
                End If

            Case "SAMV"  'ABSOLUTE MOVE; SPECIFYING START, DELTA, AND FINAL FREQ
                If bNumeric = True Then
                    TxtOut.Text = sS
                    bSend = True
                Else
                    MsgBox("Parameter missing for SAMV command")
                End If

            Case "SRMV"  'RELATIVE MOVE; SPECIFYING START, DELTA, AND FINAL FREQ
                If bNumeric = True Then
                    TxtOut.Text = sS
                    bSend = True
                Else
                    MsgBox("Parameter missing for SRMV command")
                End If

            Case "STOP" 'STOP MOTOR
                TxtOut.Text = sS
                bSend = True

            Case "STAT" 'GET STATUS OF MOTORS
                TxtOut.Text = sS
                bSend = True

            Case "ACCF"  'SET MAX STEPPING RATE OF MOTOR
                If bNumeric = True Then
                    TxtOut.Text = sS
                    bSend = True
                Else
                    MsgBox("Parameter missing for ACCF command")
                End If

            Case "ACCS"  'SET START STEP RATE
                If bNumeric = True Then
                    TxtOut.Text = sS
                    bSend = True
                Else
                    MsgBox("Parameter missing for ACCS command")
                End If

            Case "ACCI"  'SET ACCELERATION INCREMENT
                If bNumeric = True Then
                    TxtOut.Text = sS
                    bSend = True
                Else
                    MsgBox("Parameter missing for ACCI command")
                End If

            Case "DRON"  'TURN DIRECTION OUTPUT ON FOR SPECIFIED TIME
                If bNumeric = True Then
                    TxtOut.Text = sS
                    bSend = True
                Else
                    MsgBox("Parameter missing for DRON command")
                End If

            Case "DROF"  'TURN DIRECTION OUTPUT OFF
                TxtOut.Text = sS
                bSend = True

            Case "DRST"  'RETURNS TIME REMAINING IN DRON
                TxtOut.Text = sS
                bSend = True

            Case "OPTN"  'SPECIFIES OPTIONS
                If bNumeric = True Then
                    TxtOut.Text = sS
                    bSend = True
                Else
                    MsgBox("Parameter missing for OPTN command")
                End If

            Case "SAVE"  'SAVE COMPATIBLE COMMANDS TO EEPROM
                If bNumeric = True Then
                    TxtOut.Text = sS
                    bSend = True
                Else
                    MsgBox("Parameter missing for SAVE command")
                End If

            Case "REL1"
                If bNumeric = True Then
                    TxtOut.Text = sS
                    bSend = True
                Else
                    MsgBox("Parameter missing for REL1 command")
                End If

            Case "REL2"
                If bNumeric = True Then
                    TxtOut.Text = sS
                    bSend = True
                Else
                    MsgBox("Parameter missing for REL2 command")
                End If

            Case "BAUD"  'SET SYMBOL RATE
                If bNumeric = True Then
                    TxtOut.Text = sS
                    bSend = True
                Else
                    MsgBox("Parameter missing for BAUD command")
                End If


        End Select

        If bSend = True Then
            If Comm1.IsOpen = True Then
                Comm1.Write(sS & Chr(13))
            End If
        End If

    End Sub

    Private Sub MainFrm_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load
        Dim i As Short
        CboCmd1.Items.Clear()
        CboCmd1.Items.Add("")
        CboCmd1.Items.Add("POSN")
        CboCmd1.Items.Add("PSTT")
        CboCmd1.Items.Add("AMOV")
        CboCmd1.Items.Add("RMOV")
        CboCmd1.Items.Add("SAMV")
        CboCmd1.Items.Add("SRMV")
        CboCmd1.Items.Add("STOP")
        CboCmd1.Items.Add("STAT")
        CboCmd1.Items.Add("ACCF")
        CboCmd1.Items.Add("ACCS")
        CboCmd1.Items.Add("ACCI")
        CboCmd1.Items.Add("DRON")
        CboCmd1.Items.Add("DROF")
        CboCmd1.Items.Add("DRST")
        CboCmd1.Items.Add("OPTN")
        CboCmd1.Items.Add("SAVE")
        CboCmd1.Items.Add("REL1")
        CboCmd1.Items.Add("REL2")
        CboCmd1.Items.Add("BAUD")

        CboCmd2.Items.Clear()
        CboCmd2.Items.Add("")
        CboCmd2.Items.Add("POSN")
        CboCmd2.Items.Add("PSTT")
        CboCmd2.Items.Add("AMOV")
        CboCmd2.Items.Add("RMOV")
        CboCmd2.Items.Add("SAMV")
        CboCmd2.Items.Add("SRMV")
        CboCmd2.Items.Add("STOP")
        CboCmd2.Items.Add("STAT")
        CboCmd2.Items.Add("ACCF")
        CboCmd2.Items.Add("ACCS")
        CboCmd2.Items.Add("ACCI")
        CboCmd2.Items.Add("DRON")
        CboCmd2.Items.Add("DROF")
        CboCmd2.Items.Add("DRST")
        CboCmd2.Items.Add("OPTN")
        CboCmd2.Items.Add("SAVE")
        CboCmd2.Items.Add("REL1")
        CboCmd2.Items.Add("REL2")
        CboCmd2.Items.Add("BAUD")

        CboCmd3.Items.Clear()
        CboCmd3.Items.Add("")
        CboCmd3.Items.Add("POSN")
        CboCmd3.Items.Add("PSTT")
        CboCmd3.Items.Add("AMOV")
        CboCmd3.Items.Add("RMOV")
        CboCmd3.Items.Add("SAMV")
        CboCmd3.Items.Add("SRMV")
        CboCmd3.Items.Add("STOP")
        CboCmd3.Items.Add("STAT")
        CboCmd3.Items.Add("ACCF")
        CboCmd3.Items.Add("ACCS")
        CboCmd3.Items.Add("ACCI")
        CboCmd3.Items.Add("DRON")
        CboCmd3.Items.Add("DROF")
        CboCmd3.Items.Add("DRST")
        CboCmd3.Items.Add("OPTN")
        CboCmd3.Items.Add("SAVE")
        CboCmd3.Items.Add("REL1")
        CboCmd3.Items.Add("REL2")
        CboCmd3.Items.Add("BAUD")

        CboCmd4.Items.Clear()
        CboCmd4.Items.Add("")
        CboCmd4.Items.Add("POSN")
        CboCmd4.Items.Add("PSTT")
        CboCmd4.Items.Add("AMOV")
        CboCmd4.Items.Add("RMOV")
        CboCmd4.Items.Add("SAMV")
        CboCmd4.Items.Add("SRMV")
        CboCmd4.Items.Add("STOP")
        CboCmd4.Items.Add("STAT")
        CboCmd4.Items.Add("ACCF")
        CboCmd4.Items.Add("ACCS")
        CboCmd4.Items.Add("ACCI")
        CboCmd4.Items.Add("DRON")
        CboCmd4.Items.Add("DROF")
        CboCmd4.Items.Add("DRST")
        CboCmd4.Items.Add("OPTN")
        CboCmd4.Items.Add("SAVE")
        CboCmd4.Items.Add("REL1")
        CboCmd4.Items.Add("REL2")
        CboCmd4.Items.Add("BAUD")

        CboCmd5.Items.Clear()
        CboCmd5.Items.Add("")
        CboCmd5.Items.Add("POSN")
        CboCmd5.Items.Add("PSTT")
        CboCmd5.Items.Add("AMOV")
        CboCmd5.Items.Add("RMOV")
        CboCmd5.Items.Add("SAMV")
        CboCmd5.Items.Add("SRMV")
        CboCmd5.Items.Add("STOP")
        CboCmd5.Items.Add("STAT")
        CboCmd5.Items.Add("ACCF")
        CboCmd5.Items.Add("ACCS")
        CboCmd5.Items.Add("ACCI")
        CboCmd5.Items.Add("DRON")
        CboCmd5.Items.Add("DROF")
        CboCmd5.Items.Add("DRST")
        CboCmd5.Items.Add("OPTN")
        CboCmd5.Items.Add("SAVE")
        CboCmd5.Items.Add("REL1")
        CboCmd5.Items.Add("REL2")
        CboCmd5.Items.Add("BAUD")

        CboCmd6.Items.Clear()
        CboCmd6.Items.Add("")
        CboCmd6.Items.Add("POSN")
        CboCmd6.Items.Add("PSTT")
        CboCmd6.Items.Add("AMOV")
        CboCmd6.Items.Add("RMOV")
        CboCmd6.Items.Add("SAMV")
        CboCmd6.Items.Add("SRMV")
        CboCmd6.Items.Add("STOP")
        CboCmd6.Items.Add("STAT")
        CboCmd6.Items.Add("ACCF")
        CboCmd6.Items.Add("ACCS")
        CboCmd6.Items.Add("ACCI")
        CboCmd6.Items.Add("DRON")
        CboCmd6.Items.Add("DROF")
        CboCmd6.Items.Add("DRST")
        CboCmd6.Items.Add("OPTN")
        CboCmd6.Items.Add("SAVE")
        CboCmd6.Items.Add("REL1")
        CboCmd6.Items.Add("REL2")
        CboCmd6.Items.Add("BAUD")

        CboCmd7.Items.Clear()
        CboCmd7.Items.Add("")
        CboCmd7.Items.Add("POSN")
        CboCmd7.Items.Add("PSTT")
        CboCmd7.Items.Add("AMOV")
        CboCmd7.Items.Add("RMOV")
        CboCmd7.Items.Add("SAMV")
        CboCmd7.Items.Add("SRMV")
        CboCmd7.Items.Add("STOP")
        CboCmd7.Items.Add("STAT")
        CboCmd7.Items.Add("ACCF")
        CboCmd7.Items.Add("ACCS")
        CboCmd7.Items.Add("ACCI")
        CboCmd7.Items.Add("DRON")
        CboCmd7.Items.Add("DROF")
        CboCmd7.Items.Add("DRST")
        CboCmd7.Items.Add("OPTN")
        CboCmd7.Items.Add("SAVE")
        CboCmd7.Items.Add("REL1")
        CboCmd7.Items.Add("REL2")
        CboCmd7.Items.Add("BAUD")

        CboCmd8.Items.Clear()
        CboCmd8.Items.Add("")
        CboCmd8.Items.Add("POSN")
        CboCmd8.Items.Add("PSTT")
        CboCmd8.Items.Add("AMOV")
        CboCmd8.Items.Add("RMOV")
        CboCmd8.Items.Add("SAMV")
        CboCmd8.Items.Add("SRMV")
        CboCmd8.Items.Add("STOP")
        CboCmd8.Items.Add("STAT")
        CboCmd8.Items.Add("ACCF")
        CboCmd8.Items.Add("ACCS")
        CboCmd8.Items.Add("ACCI")
        CboCmd8.Items.Add("DRON")
        CboCmd8.Items.Add("DROF")
        CboCmd8.Items.Add("DRST")
        CboCmd8.Items.Add("OPTN")
        CboCmd8.Items.Add("SAVE")
        CboCmd8.Items.Add("REL1")
        CboCmd8.Items.Add("REL2")
        CboCmd8.Items.Add("BAUD")

        CboCmd9.Items.Clear()
        CboCmd9.Items.Add("")
        CboCmd9.Items.Add("POSN")
        CboCmd9.Items.Add("PSTT")
        CboCmd9.Items.Add("AMOV")
        CboCmd9.Items.Add("RMOV")
        CboCmd9.Items.Add("SAMV")
        CboCmd9.Items.Add("SRMV")
        CboCmd9.Items.Add("STOP")
        CboCmd9.Items.Add("STAT")
        CboCmd9.Items.Add("ACCF")
        CboCmd9.Items.Add("ACCS")
        CboCmd9.Items.Add("ACCI")
        CboCmd9.Items.Add("DRON")
        CboCmd9.Items.Add("DROF")
        CboCmd9.Items.Add("DRST")
        CboCmd9.Items.Add("OPTN")
        CboCmd9.Items.Add("SAVE")
        CboCmd9.Items.Add("REL1")
        CboCmd9.Items.Add("REL2")
        CboCmd9.Items.Add("BAUD")

        CboCmd10.Items.Clear()
        CboCmd10.Items.Add("")
        CboCmd10.Items.Add("POSN")
        CboCmd10.Items.Add("PSTT")
        CboCmd10.Items.Add("AMOV")
        CboCmd10.Items.Add("RMOV")
        CboCmd10.Items.Add("SAMV")
        CboCmd10.Items.Add("SRMV")
        CboCmd10.Items.Add("STOP")
        CboCmd10.Items.Add("STAT")
        CboCmd10.Items.Add("ACCF")
        CboCmd10.Items.Add("ACCS")
        CboCmd10.Items.Add("ACCI")
        CboCmd10.Items.Add("DRON")
        CboCmd10.Items.Add("DROF")
        CboCmd10.Items.Add("DRST")
        CboCmd10.Items.Add("OPTN")
        CboCmd10.Items.Add("SAVE")
        CboCmd10.Items.Add("REL1")
        CboCmd10.Items.Add("REL2")
        CboCmd10.Items.Add("BAUD")

        CboMotor1.Items.Clear()
        CboMotor1.Items.Add("")
        CboMotor1.Items.Add("@01")
        CboMotor1.Items.Add("@02")
        CboMotor1.Items.Add("@03")
        CboMotor1.Items.Add("@04")

        CboMotor2.Items.Clear()
        CboMotor2.Items.Add("")
        CboMotor2.Items.Add("@01")
        CboMotor2.Items.Add("@02")
        CboMotor2.Items.Add("@03")
        CboMotor2.Items.Add("@04")

        CboMotor3.Items.Clear()
        CboMotor3.Items.Add("")
        CboMotor3.Items.Add("@01")
        CboMotor3.Items.Add("@02")
        CboMotor3.Items.Add("@03")
        CboMotor3.Items.Add("@04")

        CboMotor4.Items.Clear()
        CboMotor4.Items.Add("")
        CboMotor4.Items.Add("@01")
        CboMotor4.Items.Add("@02")
        CboMotor4.Items.Add("@03")
        CboMotor4.Items.Add("@04")

        CboMotor5.Items.Clear()
        CboMotor5.Items.Add("")
        CboMotor5.Items.Add("@01")
        CboMotor5.Items.Add("@02")
        CboMotor5.Items.Add("@03")
        CboMotor5.Items.Add("@04")

        CboMotor6.Items.Clear()
        CboMotor6.Items.Add("")
        CboMotor6.Items.Add("@01")
        CboMotor6.Items.Add("@02")
        CboMotor6.Items.Add("@03")
        CboMotor6.Items.Add("@04")

        CboMotor7.Items.Clear()
        CboMotor7.Items.Add("")
        CboMotor7.Items.Add("@01")
        CboMotor7.Items.Add("@02")
        CboMotor7.Items.Add("@03")
        CboMotor7.Items.Add("@04")

        CboMotor8.Items.Clear()
        CboMotor8.Items.Add("")
        CboMotor8.Items.Add("@01")
        CboMotor8.Items.Add("@02")
        CboMotor8.Items.Add("@03")
        CboMotor8.Items.Add("@04")

        CboMotor9.Items.Clear()
        CboMotor9.Items.Add("")
        CboMotor9.Items.Add("@01")
        CboMotor9.Items.Add("@02")
        CboMotor9.Items.Add("@03")
        CboMotor9.Items.Add("@04")

        CboMotor10.Items.Clear()
        CboMotor10.Items.Add("")
        CboMotor10.Items.Add("@01")
        CboMotor10.Items.Add("@02")
        CboMotor10.Items.Add("@03")
        CboMotor10.Items.Add("@04")

        Comm1.Close()

        For i = 1 To MAX_COMMANDS
            UIstore(i, 1) = Convert.ToString(i)
        Next i


    End Sub

    Public Sub mnuPort_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles mnuPort.Click
        frmSetupPort.Show()
    End Sub

    Private Sub Timer1_Tick(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Timer1.Tick
        Dim bfound As Boolean
        Dim sMotor As String
        Dim sCommand As String
        Dim sParam As String
        Dim i As Short


        scaler = Line10.Text - 10

        If sourcefile = "" Then
            SaveToolStripMenuItem.Enabled = False
        Else
            SaveToolStripMenuItem.Enabled = True
        End If

        If bRun = True Then
            If CmdStage = 0 Then
                bfound = False
                While bfound = False
                    CommandNo = CommandNo + 1

                    If Line10.Text = MAX_COMMANDS And CommandNo > 9 Then
                        CommandNo = 1

                        Repeats = Repeats + 1
                        NumRepeats = Val(TxtRepeats.Text)

                        If Repeats >= NumRepeats Then
                            bRun = False
                            bfound = True
                        End If


                        'pageguard = True
                        'Repeats = Repeats + 1
                        'If pageguard Then                            
                        'While Line1.Text <> "1"
                        'Call PageBack()
                        'End While

                        While Line1.Text <> "1"
                            Call PageBack()
                        End While
                    End If

            If CommandNo > 10 Then
                TxtNoRepeats.Text = Str(Repeats)
                CommandNo = 1
                If Line1.Text <> MAX_COMMANDS - 9 Then
                    Call PageForward()
                    'Repeats = Repeats - 1
                End If
            End If

            sMotor = ""
            sCmd = ""
            sCommand = ""
            sParam = ""

            If CommandNo = 1 Then
                sMotor = CboMotor1.Text
                sCmd = CboCmd1.Text
                sParam = TxtParam1.Text
                sCommand = sMotor + " " + sCmd + " " + sParam
                bfound = True
            End If

            If CommandNo = 2 Then
                sMotor = CboMotor2.Text
                sCmd = CboCmd2.Text
                sParam = TxtParam2.Text
                sCommand = sMotor + " " + sCmd + " " + sParam
                bfound = True
            End If

            If CommandNo = 3 Then
                sMotor = CboMotor3.Text
                sCmd = CboCmd3.Text
                sParam = TxtParam3.Text
                sCommand = sMotor + " " + sCmd + " " + sParam
                bfound = True
            End If

            If CommandNo = 4 Then
                sMotor = CboMotor4.Text
                sCmd = CboCmd4.Text
                sParam = TxtParam4.Text
                sCommand = sMotor + " " + sCmd + " " + sParam
                bfound = True
            End If

            If CommandNo = 5 Then
                sMotor = CboMotor5.Text
                sCmd = CboCmd5.Text
                sParam = TxtParam5.Text
                sCommand = sMotor + " " + sCmd + " " + sParam
                bfound = True
            End If

            If CommandNo = 6 Then
                sMotor = CboMotor6.Text
                sCmd = CboCmd6.Text
                sParam = TxtParam6.Text
                sCommand = sMotor + " " + sCmd + " " + sParam
                bfound = True
            End If

            If CommandNo = 7 Then
                sMotor = CboMotor7.Text
                sCmd = CboCmd7.Text
                sParam = TxtParam7.Text
                sCommand = sMotor + " " + sCmd + " " + sParam
                bfound = True
            End If

            If CommandNo = 8 Then
                sMotor = CboMotor8.Text
                sCmd = CboCmd8.Text
                sParam = TxtParam8.Text
                sCommand = sMotor + " " + sCmd + " " + sParam
                bfound = True
            End If

            If CommandNo = 9 Then
                sMotor = CboMotor9.Text
                sCmd = CboCmd9.Text
                sParam = TxtParam9.Text
                sCommand = sMotor + " " + sCmd + " " + sParam
                bfound = True
            End If

            If CommandNo = 10 Then
                sMotor = CboMotor10.Text
                sCmd = CboCmd10.Text
                sParam = TxtParam10.Text
                sCommand = sMotor + " " + sCmd + " " + sParam
                bfound = True

                'If Line1.Text <> MAX_COMMANDS - 9 Then
                'Call PageForward()
                'Repeats = Repeats - 1
                'End If
            End If

            If sCmd <> "" Then
                If Comm1.IsOpen = True Then
                    TxtStep.Text = Str(CommandNo + scaler)

                    TxtOut.Text = sCommand
                    Dim serialstring As String = sCommand + Chr(13) + Chr(10)
                    Comm1.Write(serialstring) 'WriteSerial(OutBuf[i],&iStatus) '@
                    CmdStage = 1
                    sResponse = ""
                    sFirstResponse = ""
                    sLastResponse = ""
                    bfound = True
                End If
            Else
                'Repeats = Repeats + 1
                NumRepeats = Val(TxtRepeats.Text)
                'MsgBox("num repeats2: " & NumRepeats)

            End If
                End While
            End If

            If CmdStage = 1 Then 'looking for a # character
                i = InStr(1, sFirstResponse, "#")
                If i > 0 Then
                    CmdStage = 0
                    If sCmd = "AMOV" Or sCmd = "RMOV" Then
                        CmdStage = 2
                    End If
                End If
            End If
            If CmdStage = 2 Then 'looking for a # character
                i = InStr(1, sLastResponse, "!")
                If i > 0 Then
                    CmdStage = 0
                End If
            End If
        End If

    End Sub

    Private Sub CmdStatus_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdStatus.Click
        If Comm1.IsOpen <> True Then
            MsgBox("Configure Comm Port", , "NO SERIAL CONNECTION")
            Exit Sub
        End If

        Dim sS As String
        sCmd = "STAT"
        sS = "@01 STAT"
        TxtOut.Text = sS
        sS = sS & Chr(13)
        If Comm1.IsOpen = True Then
            Comm1.Write(sS)
        End If

    End Sub

    Private Sub LoadTestRoutineToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles LoadTestRoutineToolStripMenuItem.Click

        UIstore(1, 2) = "@01"
        UIstore(1, 3) = "REL1"
        UIstore(1, 4) = "1"

        UIstore(2, 2) = "@01"
        UIstore(2, 3) = "REL2"
        UIstore(2, 4) = "1"

        UIstore(3, 2) = "@01"
        UIstore(3, 3) = "REL1"
        UIstore(3, 4) = "0"

        UIstore(4, 2) = "@01"
        UIstore(4, 3) = "REL2"
        UIstore(4, 4) = "0"

        UIstore(5, 2) = "@01"
        UIstore(5, 3) = "AMOV"
        UIstore(5, 4) = "1000 1000 1000 1000"

        UIstore(6, 2) = "@01"
        UIstore(6, 3) = "PSTT"
        UIstore(6, 4) = ""

        UIstore(7, 2) = "@01"
        UIstore(7, 3) = "RMOV"
        UIstore(7, 4) = "-1000 -1000 -1000 -1000"

        UIstore(8, 2) = "@01"
        UIstore(8, 3) = "PSTT"
        UIstore(8, 4) = ""

        Call RetrieveUI()

    End Sub

    Private Sub GetPosition_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles GetPosition.Click
        Dim sS As String

        If Comm1.IsOpen <> True Then
            MsgBox("Configure Comm Port", , "NO SERIAL CONNECTION")
            Exit Sub
        End If

        sCmd = "PSTT"
        sS = "@01 PSTT"
        TxtOut.Text = sS
        sS = sS & Chr(13)
        If Comm1.IsOpen = True Then
            Comm1.Write(sS)
        End If
    End Sub

    Private Sub CmdStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdStop.Click
        Dim sS As String
        Dim i As Integer
        sCmd = "STOP"

        bRun = False

        For i = 1 To 9
            sS = String.Format("@0{0} STOP", i)
            TxtOut.Text = sS
            sS = sS & Chr(13)

            If Comm1.IsOpen = True Then
                Comm1.Write(sS)
            End If
        Next i

        For i = 10 To 16
            sS = String.Format("@{0} STOP", i)
            TxtOut.Text = sS
            sS = sS & Chr(13)

            If Comm1.IsOpen = True Then
                Comm1.Write(sS)
            End If
        Next i


    End Sub

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        Comm1.Close()
        Me.Close()

    End Sub

    Sub StoreUI()
        Dim linenum As Integer

        For Each ctrl In ProgramBox.Controls
            If TypeOf ctrl Is Label Then
                If ctrl.Name.StartsWith("Line") Then
                    linenum = Convert.ToInt32(Mid(ctrl.Name, 5))
                    UIstore(linenum + scaler, 1) = ctrl.Text
                End If
            End If

            If TypeOf ctrl Is ComboBox Then
                If ctrl.Name.StartsWith("CboMotor") Then
                    linenum = Convert.ToInt32(Mid(ctrl.Name, 9))
                    UIstore(linenum + scaler, 2) = ctrl.Text
                End If

                If ctrl.Name.StartsWith("CboCmd") Then
                    linenum = Convert.ToInt32(Mid(ctrl.Name, 7))
                    UIstore(linenum + scaler, 3) = ctrl.Text
                End If
            End If

            If TypeOf ctrl Is TextBox Then
                If ctrl.Name.StartsWith("TxtParam") Then
                    linenum = Convert.ToInt32(Mid(ctrl.Name, 9))
                    UIstore(linenum + scaler, 4) = ctrl.Text
                End If
            End If
        Next
    End Sub

    Sub RetrieveUI()
        Dim i As Integer

        For i = 1 To MAX_COMMANDS
            For Each ctrl In ProgramBox.Controls

                If ctrl.Name = String.Format("Line{0}", i) Then
                    ctrl.Text = UIstore(i + scaler, 1)
                End If

                If ctrl.Name = String.Format("CboMotor{0}", i) Then
                    ctrl.Text = UIstore(i + scaler, 2)
                End If

                If ctrl.Name = String.Format("CboCmd{0}", i) Then
                    ctrl.Text = UIstore(i + scaler, 3)
                End If

                If ctrl.Name = String.Format("TxtParam{0}", i) Then
                    ctrl.Text = UIstore(i + scaler, 4)
                End If

            Next
        Next i

    End Sub

    Private Sub CmdNext_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdNext.Click
        Call PageForward()

    End Sub
    Sub PageForward()
        If scaler > MAX_COMMANDS - 20 Then
            MsgBox("Control is at its limit", , "ERROR")
            Exit Sub
        End If

        Call StoreUI()
        scaler = scaler + 10
        Call RetrieveUI()

    End Sub

    Private Sub CmdInsert_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdInsert.Click
        Dim linenumber, i As Integer
        Dim ProxMaxCmd As Integer = MAX_COMMANDS

        On Error GoTo errhandler
        Call StoreUI()

        linenumber = InputBox("Insert at line:", "INSERT")

        If IsNumeric(linenumber) Then

            While ProxMaxCmd >= linenumber
                For i = 2 To 4
                    UIstore(ProxMaxCmd + 1, i) = UIstore(ProxMaxCmd, i)

                    If ProxMaxCmd = linenumber Then
                        UIstore(ProxMaxCmd, i) = ""
                    End If

                Next i

                ProxMaxCmd = ProxMaxCmd - 1
            End While

            Call RetrieveUI()

        Else
            MsgBox("Number must be an integer", , "INVALID INPUT")
errhandler:
            Exit Sub

        End If

    End Sub

    Private Sub CmdDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdDelete.Click
        Dim linenumber, i, linecounter As Integer

        On Error GoTo errhandler
        Call StoreUI()

        linenumber = InputBox("Delete line:", "DELETE")

        If IsNumeric(linenumber) Then
            linecounter = linenumber

            While linecounter < MAX_COMMANDS
                For i = 2 To 4
                    UIstore(linecounter, i) = UIstore(linecounter + 1, i)
                Next i

                linecounter = linecounter + 1
            End While

            Call RetrieveUI()

        Else
            MsgBox("Number must be an integer", , "INVALID INPUT")
errhandler:
            Exit Sub

        End If
    End Sub

    Sub SaveAFile()
        Dim i, j As Integer

        Call StoreUI()

        FileOpen(1, sourcefile, OpenMode.Random)

        For i = 1 To MAX_COMMANDS
            For j = 1 To 4
                FilePutObject(1, UIstore(i, j))
            Next j
        Next i

        FileClose(1)

    End Sub

    Sub LoadAFile()
        Dim i, j As Integer

        FileOpen(1, sourcefile, OpenMode.Random)

        For i = 1 To MAX_COMMANDS
            For j = 1 To 4
                FileGetObject(1, UIstore(i, j))
            Next

        Next i

        FileClose(1)

        Call RetrieveUI()

    End Sub

    Private Sub SaveToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveToolStripMenuItem.Click
        Call SaveAFile()
    End Sub

    Private Sub SaveAsToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles SaveAsToolStripMenuItem.Click
        Dim CMFile1Save As New SaveFileDialog
        Dim didsave As Integer

        CMFile1Save.Title = "Save SetUp File"
        CMFile1Save.Filter = "All files (*.SUF)|*.SUF"
        CMFile1Save.FileName = ""
        didsave = CMFile1Save.ShowDialog()

        If didsave = DialogResult.Cancel Then
            Exit Sub
        Else
            sourcefile = CMFile1Save.FileName
        End If

        Call SaveAFile()

    End Sub

    Private Sub OpenToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles OpenToolStripMenuItem.Click
        Dim CMFile1Open As New OpenFileDialog

        CMFile1Open.Title = "Open SetUp File"
        CMFile1Open.Filter = "All files (*.SUF)|*.SUF"
        CMFile1Open.FilterIndex = 2
        CMFile1Open.ShowDialog()

        sourcefile = CMFile1Open.FileName

        Call LoadAFile()

    End Sub

    Private Sub NewToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NewToolStripMenuItem.Click
        Dim i, j As Integer

        sourcefile = ""

        For i = 1 To MAX_COMMANDS
            For j = 2 To 4
                UIstore(i, j) = ""
            Next j
        Next i

        Call RetrieveUI()

    End Sub

    Private Sub CmdPrev_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CmdPrev.Click
        Call PageBack()

    End Sub

    Sub PageBack()
        If scaler < 1 Then
            MsgBox("Control is at its limit", , "ERROR")
            Exit Sub
        End If

        Call StoreUI()
        scaler = scaler - 10
        Call RetrieveUI()

    End Sub


End Class